#!/bin/sh

getWirelessInfId() {
  local ssid="$1"
  local radio=`getRadioMode $2`

  [ "$mode" == "5G" ] && mode=1 || mode=0
  ssid=$((ssid - 1))
  [ "$ssid" == 0 ] && ssid=""

  echo "${mode}${ssid}"
}

# getWirelessInf(index, radioId)
getWirelessInf() {
  echo "ath`getWirelessInfId $1 $2`"
}

# getStationList(index, ssid, radioId)
getStationList() {
  local ifName=`getWirelessInf $1 $3`

  wlanconfig $ifName list | grep -v ADDR | awk '{print $1}' | tr "\n" ";"
}

getSsidName() {
  local ifName=`getWirelessInf $1 $3`

  iwinfo | grep $ifName | awk -F'"' '{print $2}'
}
