#!/bin/ash

[ -z "$ROOT" ] && ROOT=/www
CONFIG=$ROOT/config
SCRIPT=$ROOT/script
TYPE=$ROOT/models

cp -rf $TYPE/init/etc/* /etc/
chmod +x /etc/hotplug.d/*
chmod +x /etc/rc.button/*

# Init model
suportedModels=`ls $TYPE 2>/dev/null | grep -v init`
model=`$SCRIPT/model.sh 2>/dev/null`

if [ -z "$model" ] ; then
	echo "Cannot detect hardware model."
	echo "Suported models: $suportedModels"
  exit 1
fi

if [ -f "$TYPE/$model/apply.sh" ] ; then
	echo "Init model $model"
	sh "$TYPE/$model/apply.sh"
fi