#!/bin/sh

# script to detect new wifi client

# $1 = wlan interface name
# $2 = AP-STA-CONNECTED |AP-STA-DISCONNECTED
# $3 = mac address

[ "$2" != AP-STA-CONNECTED ] && exit 0

[ -z "$ROOT" ] && ROOT=/www
CONFIG=$ROOT/config
SCRIPT=$ROOT/script

source $CONFIG/ap.conf
source $CONFIG/ng.conf

source $SCRIPT/utils/hotspot.sh
source $SCRIPT/utils/wifi.sh

mac=$3
ssid=`echo $1 | sed 's/wlan\([0-9]\).*/\1/'`
[ `isHotspotEnabledOnSsid $ssid` ] || exit 0

inf=`getSsidInf $ssid`
ip=`cat /proc/net/arp | grep $mac | grep $inf | awk '{print $1}'`

[ -z "$ip" ] && exit 0

echo "ip $ip ($mac) connected to ssid $ssid" >> /tmp/hostapd.log
/usr/bin/lua $SCRIPT/session/autologin.lua $ssid $ip
