#!/bin/sh

# session=
#   error: false,
#   limitations:
#     dataRemaining: 1073742848
#     expireDate: 2017-12-07T06:46:08.502Z
#     maxDevice: 1
#     maxDownload: 4194304
#     maxUpload: 4194304
#     sessionTimeout: 600
#     timeRemaining: 3600
#   session:
#     id: AV-_FHn1WvquMTUFKyTy
#     ip: 10.14.1.248
#     lastActiveAt: 2017-11-15T09:48:30.999Z
#     mac: 0C:30:21:62:F0:8C
#     ssid: 1
#     startedAt: 2017-11-15T09:48:30.999Z
#     totalDownload: 0
#     totalTime: 0
#     totalUpload: 0
#     updatedAt: 2017-11-15T09:48:30.999Z

[ -z "$ROOT" ] && ROOT=/www
CONFIG=$ROOT/config
SCRIPT=$ROOT/script

[ -f $CONFIG/ng.conf ] && source $CONFIG/ng.conf
source $CONFIG/ap.conf

source /usr/share/libubox/jshn.sh
source $SCRIPT/utils/date.sh
source $SCRIPT/utils/random.sh
source $SCRIPT/utils/wifi.sh
source $SCRIPT/utils/hotspot.sh
source $SCRIPT/utils/network.sh
source $SCRIPT/utils/qos.sh

# Find ip from mac if not provided
if [ -z "$ip" ] ; then
  infName=`getSsidInf $ssid`
  ip=`getIpFromMac $mac $infName`
fi

baseDir="/data/hotspot${ssid}"
sessionsDir="$baseDir/sessions"
sessionsMacDir="$baseDir/sessions-mac"
mkdir -p "$sessionsDir"
mkdir -p "$sessionsMacDir"

if [ -z "$id" ] ; then
  id=`echo "$mac" | tr '[A-Z]' '[a-z]' | sed s/://g`
  id="${id}-`nowAsUnitEpoch`"
  notSync=true
fi

sessionDir="$sessionsDir/$id"
mkdir -p "$sessionDir"
cd "$sessionDir"

echo -n "$id" > sessionId
echo -n "$notSync" > notSync

echo -n "$mac" > mac
ln -s "$sessionDir" "$sessionsMacDir/$mac"

echo -n 0 > totalDownload
echo -n 0 > totalUpload
echo -n 0 > totalTime

echo -n `isoToUnitEpoch "$startedAt"` > startedAt
cp startedAt lastActiveAt

[ ! -z "$idleTimeout" ] && echo -n "$idleTimeout" > idleTimeout

# check limitations
# expire
[ ! -z "$expireDate" ] && echo -n `isoToUnitEpoch "$expireDate"` > expireDate

# session timeout
[ ! -z "$sessionTimeout" ] && echo -n "$sessionTimeout" > sessionTimeout

# max data
[ ! -z "$dataRemaining" ] && echo -n "$dataRemaining" > dataRemaining

# max time
[ ! -z "$timeRemaining" ] &&  -n "$timeRemaining" > timeRemaining

# qos
[ ! -z "$maxDownload" ] ; echo -n "$maxDownload" > maxDownload
[ ! -z "$maxUpload" ] ; echo -n "$maxUpload" > maxUpload


# Allow user
if [ ! -z "$ip" ] ; then
  addIpToIpset $ssid $ip
  echo -n "$ip" > ipOnThisDevice

  # Set QOS
  [ ! -z "$maxDownload" ] && enableQosOfIpOnSsid $ssid $ip "$maxDownload"
fi
