#!/bin/sh

[ -z "$ROOT" ] && ROOT=/www
CONFIG=$ROOT/config
SCRIPT=$ROOT/script
TYPE=$ROOT/models

md5() {
	md5sum $1 | awk '{ print $1 }'
}

echo "Reload config"

hashWirelessOld=`md5 /etc/config/wireless`
hashNetworkOld=`md5 /etc/config/network`
hashDhcpOld=`md5 /etc/config/dhcp`
hashUhttpdOld=`md5 /etc/config/uhttpd`

backupDir="/tmp/backup"
[ -s "$backupDir/wireless" ] && hashWirelessOld=`md5 "$backupDir/wireless"`
[ -s "$backupDir/network" ] && hashNetworkOld=`md5 "$backupDir/network"`
[ -s "$backupDir/dhcp" ] && hashDhcpOld=`md5 "$backupDir/dhcp"`
[ -s "$backupDir/uhttpd" ] && hashUhttpdOld=`md5 "$backupDir/uhttpd"`

$SCRIPT/setup/setup.sh no

hashWirelessNew=`md5 /etc/config/wireless`
hashNetworkNew=`md5 /etc/config/network`
hashDhcpNew=`md5 /etc/config/dhcp`
hashUhttpdNew=`md5 /etc/config/uhttpd`

echo
if [ "$hashNetworkOld" != "$hashNetworkNew" ] ; then
	echo "  Reload network config"
	/etc/init.d/network reload
	hashDhcpNew='reload'
	sleep 2
fi

if [ "$hashWirelessOld" != "$hashWirelessNew" ] ; then
	echo "  Reload wireless config"
	wifi
	sleep 2
fi

if [ "$hashDhcpOld" != "$hashDhcpNew" ] ; then
	echo "  Reload dhcp config"
	/etc/init.d/dnsmasq restart
fi

if [ "$hashUhttpdOld" != "$hashUhttpdNew" ] ; then
	echo "  Reload hotspot config"
	/etc/init.d/uhttpd restart
fi

echo "  Reload ng_ap"
[ -z "$skip" ] && /etc/init.d/ng_ap2 restart

echo
echo "Done"
