#!/bin/sh

[ -z "$ROOT" ] && ROOT=/www
CONFIG=$ROOT/config
SCRIPT=$ROOT/script

[ -f $CONFIG/ng.conf ] && source $CONFIG/ng.conf
source $CONFIG/ap.conf
source $CONFIG/api.conf

source $SCRIPT/utils/stat.sh
source $SCRIPT/utils/network.sh
source $SCRIPT/utils/wifi.sh
source $SCRIPT/utils/wifi-extend.sh

echo "ng-report started" >&2

reportFile=`mktemp`

# system
getSystemReport >> "$reportFile"
getNetworkReport >> "$reportFile"
echo "version `cat $ROOT/version`" >> "$reportFile"

# stations
ssids=`getEnabledSsidList`
radios=`getRadioCount`
index=0
for ssid in $ssids ; do
  index=$((index + 1))
  for radio in `seq 1 $radios` ; do
    mode=`getRadioMode $radio`
    [ ! -n "$mode" ] && mode=2G

    ssidName=`getSsidName $index $ssid $radio`
    echo "ssid $ssid $mode $ssidName" >> "$reportFile"

    station=`getStationList $index $ssid $radio | tr "\n" " "`
    echo "station $ssid $mode $station" >> "$reportFile"
  done
done

cat "$reportFile"
rm "$reportFile"
