dofile "/www/web/wifi/cgiutils.lua"
dofile "/www/web/wifi/cgiutils-extra.lua"
dofile "/www/web/wifi/common-handler.lua"

dofile "/www/config/ng.conf"
dofile "/www/config/api.conf"

JSON = (loadfile "/www/web/wifi/JSON.lua")()

local function unAutoLogin(env)
  local ip = env.REMOTE_ADDR
  local ssid = getSsid(env)
  local cmd = "ipset del -! autologin" .. ssid .. " " .. ip
  pcall(cmdCall, cmd)
end

local function backToHotspot(env)
  redirect("http://" .. getServerHost(env) .. "/wifi")
end

function autologin(env)
  local ip = env.REMOTE_ADDR
  log({ip = ip, message = "auto login"})

  local res = callGetCurrentSession(env)
  if res.session ~= nil then
    log({ip = ip, message = "has current session"})
    _bypass(env, res)

    handleLoggedIn(env, true)
  else
    backToHotspot(env)
  end
end

function handle_request(env)
  if not env.HTTP_USER_AGENT then
    env.HTTP_USER_AGENT = env.headers["User-Agent"] or env.headers["user-agent"]
  end

  log(env.headers)
  unAutoLogin(env)

  if isLoggedIn(env) then
    handleLoggedIn(env, true)
  elseif not isAutoLoginEnabled(env) then
    backToHotspot(env)
  else
    autologin(env)
  end
end
